(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'react', 'filepicker-js', 'draft-js'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('react'), require('filepicker-js'), require('draft-js'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.react, global.filepickerJs, global.draftJs);
    global.ImageButton = mod.exports;
  }
})(this, function (exports, _react, _filepickerJs, _draftJs) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _react2 = _interopRequireDefault(_react);

  var _filepickerJs2 = _interopRequireDefault(_filepickerJs);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  var _createClass = function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  }();

  function _possibleConstructorReturn(self, call) {
    if (!self) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return call && (typeof call === "object" || typeof call === "function") ? call : self;
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
  }

  var ImageButton = function (_React$Component) {
    _inherits(ImageButton, _React$Component);

    function ImageButton(props) {
      _classCallCheck(this, ImageButton);

      var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(ImageButton).call(this, props));

      _this.insertImage = _this.insertImage.bind(_this);
      return _this;
    }

    _createClass(ImageButton, [{
      key: 'insertImage',
      value: function insertImage() {
        var _props = this.props;
        var filePickerKey = _props.filePickerKey;
        var onChange = _props.onChange;
        var editorState = _props.editorState;

        console.log('clicked');

        _filepickerJs2.default.setKey(filePickerKey);
        _filepickerJs2.default.pickAndStore({
          mimetype: 'image/*',
          multiple: false
        }, {}, function (Blobs) {
          var entityKey = _draftJs.Entity.create('IMAGE', 'IMMUTABLE', { src: Blobs[0].url });
          onChange(_draftJs.AtomicBlockUtils.insertAtomicBlock(editorState, entityKey, ' '));
        });
      }
    }, {
      key: 'render',
      value: function render() {
        return _react2.default.createElement(
          'button',
          {
            type: 'button',
            className: 'button',
            onClick: this.insertImage
          },
          _react2.default.createElement('i', { className: 'fa fa-camera' })
        );
      }
    }]);

    return ImageButton;
  }(_react2.default.Component);

  exports.default = ImageButton;
});