(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'react', 'draft-js', './Audio.jsx', './Image.jsx', './Video.jsx'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('react'), require('draft-js'), require('./Audio.jsx'), require('./Image.jsx'), require('./Video.jsx'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.react, global.draftJs, global.Audio, global.Image, global.Video);
    global.Media = mod.exports;
  }
})(this, function (exports, _react, _draftJs, _Audio, _Image, _Video) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _react2 = _interopRequireDefault(_react);

  var _Audio2 = _interopRequireDefault(_Audio);

  var _Image2 = _interopRequireDefault(_Image);

  var _Video2 = _interopRequireDefault(_Video);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  var Media = function Media(_ref) {
    var block = _ref.block;

    var entity = _draftJs.Entity.get(block.getEntityAt(0));

    var _entity$getData = entity.getData();

    var src = _entity$getData.src;

    var type = entity.getType();

    var media = void 0;
    if (type === 'AUDIO') {
      media = _react2.default.createElement(_Audio2.default, { src: src });
    } else if (type === 'IMAGE') {
      media = _react2.default.createElement(_Image2.default, { src: src });
    } else if (type === 'VIDEO') {
      media = _react2.default.createElement(_Video2.default, { src: src });
    }

    return media;
  };

  exports.default = Media;
});