(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'react', 'react-dom', './ImageButton.jsx'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('react'), require('react-dom'), require('./ImageButton.jsx'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.react, global.reactDom, global.ImageButton);
    global.Sidebar = mod.exports;
  }
})(this, function (exports, _react, _reactDom, _ImageButton) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _react2 = _interopRequireDefault(_react);

  var _reactDom2 = _interopRequireDefault(_reactDom);

  var _ImageButton2 = _interopRequireDefault(_ImageButton);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  var _createClass = function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  }();

  function _possibleConstructorReturn(self, call) {
    if (!self) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return call && (typeof call === "object" || typeof call === "function") ? call : self;
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
  }

  var Sidebar = function (_Component) {
    _inherits(Sidebar, _Component);

    function Sidebar(props) {
      _classCallCheck(this, Sidebar);

      var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(Sidebar).call(this, props));

      _this.state = {
        top: 0
      };

      _this.getSelectedBlockElement = _this.getSelectedBlockElement.bind(_this);
      _this.setBarPosition = _this.setBarPosition.bind(_this);
      return _this;
    }

    _createClass(Sidebar, [{
      key: 'componentDidUpdate',
      value: function componentDidUpdate() {
        this.setBarPosition();
      }
    }, {
      key: 'getSelectedBlockElement',
      value: function getSelectedBlockElement() {
        // Finds the block parent of the current selection
        // https://github.com/facebook/draft-js/issues/45
        var selection = window.getSelection();
        if (selection.rangeCount === 0) {
          return null;
        }
        var node = selection.getRangeAt(0).startContainer;

        do {
          if (node.getAttribute && node.getAttribute('data-block') == 'true') {
            return node;
          }
          node = node.parentNode;
        } while (node !== null);
      }
    }, {
      key: 'setBarPosition',
      value: function setBarPosition() {
        var container = _reactDom2.default.findDOMNode(this.refs.container);

        var element = this.getSelectedBlockElement();

        if (!element) {
          return;
        }

        var top = Math.floor(element.getBoundingClientRect().top - 4 - (container.getBoundingClientRect().top - document.documentElement.clientTop));

        if (this.state.top !== top) {
          this.setState({
            top: top
          });
        }
      }
    }, {
      key: 'render',
      value: function render() {
        var top = this.state.top;
        var _props = this.props;
        var onChange = _props.onChange;
        var editorState = _props.editorState;
        var filePickerKey = _props.filePickerKey;


        return _react2.default.createElement(
          'div',
          { ref: 'container', style: { position: 'absolute', height: '100%' } },
          _react2.default.createElement(
            'div',
            { style: { position: 'relative', top: top + 'px' } },
            _react2.default.createElement(_ImageButton2.default, {
              editorState: editorState,
              onChange: onChange,
              filePickerKey: filePickerKey
            })
          )
        );
      }
    }]);

    return Sidebar;
  }(_react.Component);

  exports.default = Sidebar;
});