import React from 'react';
import filepicker from 'filepicker-js';
import { Entity, AtomicBlockUtils } from 'draft-js';

class ImageButton extends React.Component {
  constructor(props) {
    super(props);

    this.insertImage = this.insertImage.bind(this);
  }

  insertImage() {
    const { filePickerKey, onChange, editorState } = this.props;
    console.log('clicked');

    filepicker.setKey(filePickerKey);
    filepicker.pickAndStore(
      {
        mimetype: 'image/*',
        multiple: false
      },
      {},
      function (Blobs) {
        const entityKey = Entity.create('IMAGE', 'IMMUTABLE', { src: Blobs[ 0 ].url });
        onChange(AtomicBlockUtils.insertAtomicBlock(
          editorState,
          entityKey,
          ' '
        ));
      }
    );
  }

  render() {
    return (
      <button
        type="button"
        className="button"
        onClick={this.insertImage}
      >
        <i className="fa fa-camera" />
      </button>
    );
  }
}

export default ImageButton;
